// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from object_recognition_msgs:srv/GetObjectInformation.idl
// generated code does not contain a copyright notice
#include "object_recognition_msgs/srv/detail/get_object_information__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `type`
#include "object_recognition_msgs/msg/detail/object_type__functions.h"

bool
object_recognition_msgs__srv__GetObjectInformation_Request__init(object_recognition_msgs__srv__GetObjectInformation_Request * msg)
{
  if (!msg) {
    return false;
  }
  // type
  if (!object_recognition_msgs__msg__ObjectType__init(&msg->type)) {
    object_recognition_msgs__srv__GetObjectInformation_Request__fini(msg);
    return false;
  }
  return true;
}

void
object_recognition_msgs__srv__GetObjectInformation_Request__fini(object_recognition_msgs__srv__GetObjectInformation_Request * msg)
{
  if (!msg) {
    return;
  }
  // type
  object_recognition_msgs__msg__ObjectType__fini(&msg->type);
}

bool
object_recognition_msgs__srv__GetObjectInformation_Request__are_equal(const object_recognition_msgs__srv__GetObjectInformation_Request * lhs, const object_recognition_msgs__srv__GetObjectInformation_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // type
  if (!object_recognition_msgs__msg__ObjectType__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  return true;
}

bool
object_recognition_msgs__srv__GetObjectInformation_Request__copy(
  const object_recognition_msgs__srv__GetObjectInformation_Request * input,
  object_recognition_msgs__srv__GetObjectInformation_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // type
  if (!object_recognition_msgs__msg__ObjectType__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  return true;
}

object_recognition_msgs__srv__GetObjectInformation_Request *
object_recognition_msgs__srv__GetObjectInformation_Request__create()
{
  object_recognition_msgs__srv__GetObjectInformation_Request * msg = (object_recognition_msgs__srv__GetObjectInformation_Request *)malloc(sizeof(object_recognition_msgs__srv__GetObjectInformation_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(object_recognition_msgs__srv__GetObjectInformation_Request));
  bool success = object_recognition_msgs__srv__GetObjectInformation_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
object_recognition_msgs__srv__GetObjectInformation_Request__destroy(object_recognition_msgs__srv__GetObjectInformation_Request * msg)
{
  if (msg) {
    object_recognition_msgs__srv__GetObjectInformation_Request__fini(msg);
  }
  free(msg);
}


bool
object_recognition_msgs__srv__GetObjectInformation_Request__Sequence__init(object_recognition_msgs__srv__GetObjectInformation_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  object_recognition_msgs__srv__GetObjectInformation_Request * data = NULL;
  if (size) {
    data = (object_recognition_msgs__srv__GetObjectInformation_Request *)calloc(size, sizeof(object_recognition_msgs__srv__GetObjectInformation_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = object_recognition_msgs__srv__GetObjectInformation_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        object_recognition_msgs__srv__GetObjectInformation_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
object_recognition_msgs__srv__GetObjectInformation_Request__Sequence__fini(object_recognition_msgs__srv__GetObjectInformation_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      object_recognition_msgs__srv__GetObjectInformation_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

object_recognition_msgs__srv__GetObjectInformation_Request__Sequence *
object_recognition_msgs__srv__GetObjectInformation_Request__Sequence__create(size_t size)
{
  object_recognition_msgs__srv__GetObjectInformation_Request__Sequence * array = (object_recognition_msgs__srv__GetObjectInformation_Request__Sequence *)malloc(sizeof(object_recognition_msgs__srv__GetObjectInformation_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = object_recognition_msgs__srv__GetObjectInformation_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
object_recognition_msgs__srv__GetObjectInformation_Request__Sequence__destroy(object_recognition_msgs__srv__GetObjectInformation_Request__Sequence * array)
{
  if (array) {
    object_recognition_msgs__srv__GetObjectInformation_Request__Sequence__fini(array);
  }
  free(array);
}

bool
object_recognition_msgs__srv__GetObjectInformation_Request__Sequence__are_equal(const object_recognition_msgs__srv__GetObjectInformation_Request__Sequence * lhs, const object_recognition_msgs__srv__GetObjectInformation_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!object_recognition_msgs__srv__GetObjectInformation_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
object_recognition_msgs__srv__GetObjectInformation_Request__Sequence__copy(
  const object_recognition_msgs__srv__GetObjectInformation_Request__Sequence * input,
  object_recognition_msgs__srv__GetObjectInformation_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(object_recognition_msgs__srv__GetObjectInformation_Request);
    object_recognition_msgs__srv__GetObjectInformation_Request * data =
      (object_recognition_msgs__srv__GetObjectInformation_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!object_recognition_msgs__srv__GetObjectInformation_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          object_recognition_msgs__srv__GetObjectInformation_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!object_recognition_msgs__srv__GetObjectInformation_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `information`
#include "object_recognition_msgs/msg/detail/object_information__functions.h"

bool
object_recognition_msgs__srv__GetObjectInformation_Response__init(object_recognition_msgs__srv__GetObjectInformation_Response * msg)
{
  if (!msg) {
    return false;
  }
  // information
  if (!object_recognition_msgs__msg__ObjectInformation__init(&msg->information)) {
    object_recognition_msgs__srv__GetObjectInformation_Response__fini(msg);
    return false;
  }
  return true;
}

void
object_recognition_msgs__srv__GetObjectInformation_Response__fini(object_recognition_msgs__srv__GetObjectInformation_Response * msg)
{
  if (!msg) {
    return;
  }
  // information
  object_recognition_msgs__msg__ObjectInformation__fini(&msg->information);
}

bool
object_recognition_msgs__srv__GetObjectInformation_Response__are_equal(const object_recognition_msgs__srv__GetObjectInformation_Response * lhs, const object_recognition_msgs__srv__GetObjectInformation_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // information
  if (!object_recognition_msgs__msg__ObjectInformation__are_equal(
      &(lhs->information), &(rhs->information)))
  {
    return false;
  }
  return true;
}

bool
object_recognition_msgs__srv__GetObjectInformation_Response__copy(
  const object_recognition_msgs__srv__GetObjectInformation_Response * input,
  object_recognition_msgs__srv__GetObjectInformation_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // information
  if (!object_recognition_msgs__msg__ObjectInformation__copy(
      &(input->information), &(output->information)))
  {
    return false;
  }
  return true;
}

object_recognition_msgs__srv__GetObjectInformation_Response *
object_recognition_msgs__srv__GetObjectInformation_Response__create()
{
  object_recognition_msgs__srv__GetObjectInformation_Response * msg = (object_recognition_msgs__srv__GetObjectInformation_Response *)malloc(sizeof(object_recognition_msgs__srv__GetObjectInformation_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(object_recognition_msgs__srv__GetObjectInformation_Response));
  bool success = object_recognition_msgs__srv__GetObjectInformation_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
object_recognition_msgs__srv__GetObjectInformation_Response__destroy(object_recognition_msgs__srv__GetObjectInformation_Response * msg)
{
  if (msg) {
    object_recognition_msgs__srv__GetObjectInformation_Response__fini(msg);
  }
  free(msg);
}


bool
object_recognition_msgs__srv__GetObjectInformation_Response__Sequence__init(object_recognition_msgs__srv__GetObjectInformation_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  object_recognition_msgs__srv__GetObjectInformation_Response * data = NULL;
  if (size) {
    data = (object_recognition_msgs__srv__GetObjectInformation_Response *)calloc(size, sizeof(object_recognition_msgs__srv__GetObjectInformation_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = object_recognition_msgs__srv__GetObjectInformation_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        object_recognition_msgs__srv__GetObjectInformation_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
object_recognition_msgs__srv__GetObjectInformation_Response__Sequence__fini(object_recognition_msgs__srv__GetObjectInformation_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      object_recognition_msgs__srv__GetObjectInformation_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

object_recognition_msgs__srv__GetObjectInformation_Response__Sequence *
object_recognition_msgs__srv__GetObjectInformation_Response__Sequence__create(size_t size)
{
  object_recognition_msgs__srv__GetObjectInformation_Response__Sequence * array = (object_recognition_msgs__srv__GetObjectInformation_Response__Sequence *)malloc(sizeof(object_recognition_msgs__srv__GetObjectInformation_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = object_recognition_msgs__srv__GetObjectInformation_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
object_recognition_msgs__srv__GetObjectInformation_Response__Sequence__destroy(object_recognition_msgs__srv__GetObjectInformation_Response__Sequence * array)
{
  if (array) {
    object_recognition_msgs__srv__GetObjectInformation_Response__Sequence__fini(array);
  }
  free(array);
}

bool
object_recognition_msgs__srv__GetObjectInformation_Response__Sequence__are_equal(const object_recognition_msgs__srv__GetObjectInformation_Response__Sequence * lhs, const object_recognition_msgs__srv__GetObjectInformation_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!object_recognition_msgs__srv__GetObjectInformation_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
object_recognition_msgs__srv__GetObjectInformation_Response__Sequence__copy(
  const object_recognition_msgs__srv__GetObjectInformation_Response__Sequence * input,
  object_recognition_msgs__srv__GetObjectInformation_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(object_recognition_msgs__srv__GetObjectInformation_Response);
    object_recognition_msgs__srv__GetObjectInformation_Response * data =
      (object_recognition_msgs__srv__GetObjectInformation_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!object_recognition_msgs__srv__GetObjectInformation_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          object_recognition_msgs__srv__GetObjectInformation_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!object_recognition_msgs__srv__GetObjectInformation_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
